#include "individual.h"
#include "smtoken.h"
#include <list>

static std::list<DelayedEvaluator *>    waitingIndividuals ;
static Semaphop                         *pWaitingSemaphop = 0 ;

static class Init {
    
    public :
    
        Init ()
        {
            RandomInit(0);
            pWaitingSemaphop = new Semaphop ;
        }
}                                        init ;

/////////////////////////
// for threaded eval
/////////////////////////
void AddWaitingIndividuals ( DelayedEvaluator *pIndividual )
{
    (*pWaitingSemaphop).PutRessourceBegin(1);
    if ( !pIndividual ) {
        EString message = "Null Stacked \n";
        write(2, message.c_str(), message.length());
    }
    waitingIndividuals.push_back(pIndividual);
    (*pWaitingSemaphop).PutRessourceEnd();
}

void *TreatWaitingIndividual ( void *pParam )
{
    DelayedEvaluator    *pIndividual ;
    
    while ( true ) {
        
        // get new board
        (*pWaitingSemaphop).GetRessourceBegin(1);
        
        // sleep(1);
        if ( waitingIndividuals.size() >= 1 ) {
            pIndividual = waitingIndividuals.front();
            waitingIndividuals.pop_front();
        } else {
            EString message = "Nothing to destack \n";
            write(2, message.c_str(), message.length());
            pIndividual = 0 ;
        }
        (*pWaitingSemaphop).GetRessourceEnd();
        
        // treat it
        if ( pIndividual ) 
            pIndividual->DelayedEval();
    }
    return 0 ;
}
